import 'dart:async';
import 'package:yona/yona.dart';
void main()async{
  var host = NetAddr.fromString("yonafediverse.com:7777");
  var user1 =await Crypto.genSK();
  var client1 = Client(MemCache(), user1, host);
  await client1.publish("client1");
  var timer1 = Timer.periodic(Duration(milliseconds: 100),(timer) async{
    try {
      var msgs = await client1.receive(10);
      for(var msg in msgs) {
        print("${Utils.parseBinaryToInt(msg.data.payload)}: ${DateTime.now().difference(msg.data.sentAt).inMilliseconds/1000}");
      }
    }catch(error){
      print("error on receive $error");
    }
  });
  var timer2 = Timer.periodic(Duration(milliseconds: 1000),(timer) async{
    try {
      await client1.send(Crypto.derivePK(user1), DateTime.now(), 1,
          Utils.int64ToBinary(timer.tick), Duration(seconds: 1));
    }catch(error){
      print("error on send $error");
    }
  });

}