import 'package:messagepack/messagepack.dart' as msgpack;

class Msg {
  final DateTime sentAt;
  final int kind;
  final List<int> payload;

  Msg(this.sentAt, this.kind, this.payload);

  List<int> encode() {
    var pack = msgpack.Packer();
    pack.packInt(sentAt.millisecondsSinceEpoch);
    pack.packInt(kind);
    pack.packBinary(payload);
    return pack.takeBytes();
  }

  static Msg decode(List<int> b) {
    var pack = msgpack.Unpacker.fromList(b);
    return Msg(DateTime.fromMillisecondsSinceEpoch(pack.unpackInt()!),
        pack.unpackInt()!, pack.unpackBinary());
  }
}
