

class Packet {

  final List<int> to;
  final List<int> from;
  final List<int> data;
  late final List<int> id;
  static const pkSize = 64;
  static const zeroID = [0,0,0,0,0,0,0,0];
  Packet(this.to, this.from, this.data, this.id);

  static Packet decode(List<int> b) {
    return Packet(
        b.sublist(1, 1 + pkSize),
        b.sublist(1 + pkSize + 8, 1 + pkSize + 8 + pkSize),
        b.sublist(1 + pkSize + 8 + pkSize),
        b.sublist(1 + pkSize, 1 + pkSize + 8));
  }

  @override
  String toString() {
    return {
      "to": to,
      "from": from,
      "id": id,
      "data": data,
    }.toString();
  }

  List<int> encode() {
    var r = [0];
    r.addAll(to.sublist(0,pkSize));
    if (id.isEmpty) {
      r.addAll(zeroID);
    }else{
      r.addAll(id.sublist(0, 8));
    }
    r.addAll(from.sublist(0,pkSize));
    r.addAll(data);
    return r;
  }
}
