import 'net_addr.dart';

class PeerInfo {
  final NetAddr longlog;
  final String name;
  final DateTime deadline;
  PeerInfo(this.longlog,this.name,this.deadline);

  Map<String, String> toMap() {
    return {"name": name, "longlog": longlog.toString(),"deadline":(deadline.millisecondsSinceEpoch~/1000).toString()};
  }
  bool isExpired(){
    return deadline.isBefore(DateTime.now());
  }
  static PeerInfo fromMap(Map<String, String> map) {
    return PeerInfo(NetAddr.fromString(map["longlog"]!), map["name"]!, DateTime.fromMillisecondsSinceEpoch(int.parse(map["deadline"]!)*1000));
  }
}
